function hex_md5(str) {
  const hash = Components.classes["@mozilla.org/security/hash;1"].createInstance(Components.interfaces.nsICryptoHash);
  // Convert string to bytes array
  const lengthOut = {}; // out param
  const bytes = uniConverter.convertToByteArray(str, lengthOut);
  // Hash
  hash.init(hash.MD5);
  hash.update(bytes, lengthOut.value);
  const md5bytes = hash.finish(false);
  // the "0"/slice stuff is to ensure all char codes give two hex chars, not just one
  var result = "";
  for (var i = 0; i < md5bytes.length; i++) {
    result += ("0" + md5bytes.charCodeAt(i).toString(16)).slice(-2);
  }
  return result;
}